<template>
    <fieldset class="form-group">
        <legend>Attributes</legend>
        
        <table class="table list-attributes">
            <thead>
             
                <td>
                    <div class="row">
                        <div class="col-md-3">Name</div>
                        <div class="col-md-3">Value</div>
                        <div class="col-md-3">Price</div>
                        <div class="col-md-3">Qty</div>
                    </div>
                <td></td>
                </td>
            </thead>
            <tbody>
             
                <tr v-for="(attribute,key) in productAttributes" :key="attribute.id">
                    <td>
                        
                     
                        <div class="row">
                            <div class="col-md-6 list-attributes"> 
                            
                            <template v-for="(total,gindex) in attribute.values">     
                          
                                <div class="row list-attributes-inner" v-bind:gindex="gindex">
                                    <div class="col-md-6">   
                                  
                                        <select class="form-control values" v-on:change="change(key,$event)">

                                            <option v-for="(attr,index) in attributeList" :key="attr.id" v-bind:value="attr.id" :selected="attr.id==total.attribute_id">
                                                {{ attr.name }} 
                                            </option>
                                        </select>
                                    </div>
                                    <div class="col-md-6 attribute-value-render">
                                    
                                        <template :set="valuesV = attributeList[total.attribute_id]"></template>
                                        
                                        <select  :name="'groups['+key+'][values]['+total.attribute_id+']'"  class="form-control values">
                                            <option v-for="(v,index) in valuesV.values" :key="v.id" v-bind:value="v.id" :selected="v.id==total.value_id">
                                                {{ v.name }} 
                                            </option>
                                        </select>
                                    </div>
                                </div>
                            </template>
                            </div>
                            <div class="col-md-3">
                                <input class="form-control" type="number" v-model="attribute.price" :name="'groups['+key+'][price]'">
                            </div>
                            <div class="col-md-3">
                                <input class="form-control" type="number" v-model="attribute.qty" :name="'groups['+key+'][qty]'">
                            </div>
                            <div class="col-md-12">
                                <button class="btn btn-secondary" v-on:click="addAttribute(key,$event)">
                                    <i class="fa fa-plus"></i>
                                    </button>
                                </div>
                        </div>
                    </td>

                    <td>
                        <button class="btn btn-error" v-on:click="remove(key,$event)">
                            <i class="fa fa-close"></i>
                        </button>
                    </td>
                </tr>
            </tbody>
        </table>
        <hr>
        <a class="btn btn-secondary add-attributes" href="#" v-on:click="add">Add Attribute</a>
    </fieldset>
</template>
<script>
import axios from "axios";
export default {
    props: ['carid'],
    data() {
        return {
            attributeList: [],
            attributeValueList: [],
            productAttributes: [],
        };
    },
    mounted() {   
        axios.get("http://cars-test.test/@dminJLB/product_attributes/"+this.carid)
        .then(res => {
            this.productAttributes = res.data;

        })
        .catch(error => {
            console.log(error)
        });
        

        axios.get("http://cars-test.test/@dminJLB/list_attributes")
        .then(res => {
            this.attributeList = res.data;

        })
        .catch(error => {
            console.log(error)
        });

        axios.get("http://cars-test.test/@dminJLB/list_attribute_values")
        .then(res => {
            this.attributeValueList = res.data;

        })
        .catch(error => {
            console.log(error)
        });

    },
    methods: {
        add: function(event){
            event.preventDefault();
            const new_array = {
                'id': '',
                'values': [
                    {
                        'attribute_id':3,
                    }
                ]
            };
    
            this.productAttributes.push(new_array);
         
        },
        remove: function(index,event) {
            event.preventDefault();   
            this.productAttributes.splice(index, 1);
        },
        makeid: function(length) {
            var result           = '';
            var characters       = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
            var charactersLength = characters.length;
            for ( var i = 0; i < length; i++ ) {
                result += characters.charAt(Math.floor(Math.random() * charactersLength));
            }
            return result;
        },
        change: function(index,event) {
            // event.target.value
            var indexevent =  event.target.value;
            var selectValue = $(event.target).closest('.list-attributes-inner').find('.attribute-value-render').children('select');
            selectValue.html('');
            // .append('<option>Please select one</option>');
            console.log(indexevent);
            selectValue.attr('name','groups['+index+'][values]['+indexevent+']');
            this.attributeValueList[indexevent].forEach((value,index) => {
                selectValue.append('<option value="'+value.id+'">'+value.name+'</option>')
            })
    
        },
        addAttribute: function(index,event){
            event.preventDefault();
            var gindex = $(event.target).closest('.row').find('.list-attributes-inner').attr('gindex');
            const new_array = {
                'attribute_id':3, //first attribute
            };
            var new_attrs = this.productAttributes[index];
       
            new_attrs.values.push(new_array);
      
        },
        _optionRender: function(){

        }
    }
};
</script>